.686
.model flat,stdcall
	
	option casemap:none
	include \masm32\include\windows.inc
	
	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	include \masm32\include\winmm.inc
	
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\winmm.lib
	
	include rsrc.inc
	
.data
	
	tc TIMECAPS <>
	
	period dd 0
	
	txtset db "Set",0
	txtclr db "Clear",0
	
	txterr db "Value out of range",0
	
.code
	
dlgproc proc hwnd:dword,msg:dword,wpar:dword,lpar:dword
	
	.if [msg] == WM_COMMAND
		
		.if word ptr [wpar+2] == 0
			
			.if word ptr [wpar] == IDC_SET
				
				.if [period] == 0
					
					invoke GetDlgItemInt,[hwnd],IDC_RES,0,0
					mov [period],eax
					
					invoke timeBeginPeriod,eax
					
					.if eax == TIMERR_NOERROR
						
						invoke SendDlgItemMessage,[hwnd],IDC_RES,EM_SETREADONLY,1,0
						invoke SetDlgItemText,[hwnd],IDC_SET,addr txtclr
						
					.else
						
						invoke MessageBox,[hwnd],addr txterr,0,MB_ICONERROR
						mov [period],0
						
					.endif
					
				.else
					
					invoke timeEndPeriod,[period]
					mov [period],0
					
					invoke SendDlgItemMessage,[hwnd],IDC_RES,EM_SETREADONLY,0,0
					invoke SetDlgItemText,[hwnd],IDC_SET,addr txtset
					
				.endif
				
			.endif
			
		.endif
		
	.elseif [msg] == WM_INITDIALOG
		
		invoke timeGetDevCaps,addr tc,sizeof tc
		
		invoke SetDlgItemInt,[hwnd],IDC_MIN,[tc.wPeriodMin],0
		invoke SetDlgItemInt,[hwnd],IDC_MAX,[tc.wPeriodMax],0
		
		mov eax,1
		ret
		
	.elseif [msg] == WM_CLOSE
		
		.if [period] != 0
			
			invoke timeEndPeriod,[period]
			
		.endif
		
		invoke EndDialog,[hwnd],0
		
	.endif
	
	xor eax,eax
	ret
	
dlgproc endp
	
start:
	
	invoke GetModuleHandle,0
	
	invoke DialogBoxParam,eax,IDD_TR,0,addr dlgproc,0
	
	invoke ExitProcess,0
	ret
	
end start